<?php if ( !defined( 'ABSPATH' ) ) exit;//PHPの宣言と直接アクセスの拒否
/*** 設定を追加したらサニタイズ関数の条件も追加すること ***/

/* セクションID haumenu_define_section_id_03_optimize() */
/* タブのスラグ haumenu_define_tab_slug_03_optimize() */
/* $option_name 設定名 haumenu_define_option_name_03_optimize() */
/* get_option GetOP03_optimize() */

/***** 親設定の有効／無効に合わせて子設定の表示方法を変更する *****/
/* 関数名・設定名は画面ごとに変えること（関数重複を防ぐ） */
/* add_action('admin_notices', 'current_pagehook');を追加してページ名を取得し、$page_fooksuffixの値を変える */
/* 連動マップ（ID => セレクター）の項目を編集する */

function haup_child_setting_view_control_03_optimize( $hook_suffix ) {
	//ページフックにより出力を判断
	$page_fooksuffix = 'ha-utilitiy_page_haumenu_page_optimize';

	if ( $page_fooksuffix !== $hook_suffix ) {
		return;
	}

	//メインスクリプトのハンドル
	$handle = 'haup-child-setting-control-js';

	// メインスクリプトが登録されていなければ終了(スクリプトの読み込みはmain-menu.phpで記述)
	if ( ! wp_script_is( $handle, 'registered' ) ) {
		return;
	}

	//設定名
	$set_name = haumenu_define_option_name_03_optimize();

	// 連動マップ（ID => セレクター）
	// 1つのIDに対して複数のCSSクラスを指定する（1つなら1行）
	$dependency_map = array(
		$set_name . 'output-ogptag' => array(
			'.ogp-twitter-ac-name-wrapper',  // Xのユーザー名
			'.ogp-facebook-id-wrapper', // FacebookのID
			'.ogp-card-size-wrapper', // カードサイズ
		),

	);

	$inner_js = "";
	foreach ( $dependency_map as $id => $selectors ) {
		foreach ( (array) $selectors as $selector ) {
			// translators: %s stands for the CSS Class & ID.
			$inner_js .= sprintf(
				"haup_apply_dependency('%s', '%s');\n",
				esc_js( $id ),
				esc_js( $selector )
			);
		}
	}

	if ( $inner_js ) {
		$js_code = "if (window.haup_apply_dependency) {\n" . $inner_js . "}";
		// 第3引数を 'after' にすることで、本体JSの直後に出力
		wp_add_inline_script( $handle, $js_code, 'after' );
	}
}
add_action( 'admin_enqueue_scripts', 'haup_child_setting_view_control_03_optimize', 20 );

/*** OGPタグの出力 ***/
/* 項目の追加とデータの更新 */
function haumenu_init_field_ogptag(){
//項目の追加
	add_settings_field(
		'output-ogptag',// $id フィールドを識別するスラッグ名
		__('OGP tag output','hima-art-utility'),// $title 設定タイトル
		'haumenu_ogptag',// $callback 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_03_optimize(), //表示させるタブのスラグ
		haumenu_define_section_id_03_optimize(), //セクションID
		array( 'class' => 'ha-settings-separate' )
	);
}

add_action( 'admin_init', 'haumenu_init_field_ogptag' );

/* 入力フォーム */
function haumenu_ogptag() {
	$set_name = haumenu_define_option_name_03_optimize(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'output-ogptag'; //個別配列名

	//テーブルに値がなかった場合の措置（PHP8.x以降への対応）
	if(isset($options[$option_name])){
		$checked = $options[$option_name];
	}else{
		$checked = '';
	}
?>
<label>
	<input type="checkbox" id="<?php echo esc_html($set_name . $option_name ); ?>" name="<?php echo esc_html($set_name . '[' .$option_name. ']'); ?>" class="wppd-ui-toggle" <?php checked( $checked , 1 ); ?> value="1">
	<p><?php esc_html_e('Outputs the OGP tag required to display the link inserted in the SNS as a card in the HTML source','hima-art-utility'); ?></p>
</label>
<?php
}

/*** Twitterのアカウント名 ***/
function haumenu_init_field_ogp_twitter_ac_name(){
//項目の追加
	add_settings_field(
		'ogp-twitter-ac-name', // 設定名
		__('X Account Name','hima-art-utility'), // 設定タイトル
		'haumenu_ogp_twitter_ac_name', // 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_03_optimize(), //表示させるタブのスラグ
		haumenu_define_section_id_03_optimize(),// $section 表示させるセクションのID
		array( 'class' => 'ha-settings-convine' )
	);

}

add_action( 'admin_init', 'haumenu_init_field_ogp_twitter_ac_name' );

/* 入力フォーム */
function haumenu_ogp_twitter_ac_name() {
	$set_name = haumenu_define_option_name_03_optimize(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'ogp-twitter-ac-name'; //個別配列名
?>
<div class="ogp-twitter-ac-name-wrapper">
<label>
	<input name="<?php echo esc_html($set_name . '['.$option_name.']'); ?>" type="text" class="transform" id="<?php echo esc_html($set_name . $option_name ); ?>" value="<?php echo esc_attr($options[ $option_name ] ?? ''); ?>">
<p><?php esc_html_e('Please enter the X account name to be output to the OGP tag.','hima-art-utility'); ?></p>
</label>
</div>
<?php
}

/*** FacebookのID ***/
function haumenu_init_field_ogp_facebook_id(){
//項目の追加
	add_settings_field(
		'ogp-facebook-id', // 設定名
		__('Facebook ID','hima-art-utility'), // 設定タイトル
		'haumenu_ogp_facebook_id', // 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_03_optimize(), //表示させるタブのスラグ
		haumenu_define_section_id_03_optimize(),// $section 表示させるセクションのID
		array( 'class' => 'ha-settings-convine' )
	);

}

add_action( 'admin_init', 'haumenu_init_field_ogp_facebook_id' );

/* 入力フォーム */
function haumenu_ogp_facebook_id() {
	$set_name = haumenu_define_option_name_03_optimize(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'ogp-facebook-id'; //個別配列名
?>
<div class="ogp-facebook-id-wrapper">
<label>
	<input name="<?php echo esc_html($set_name . '['.$option_name.']'); ?>" type="text" class="transform" id="<?php echo esc_html($set_name . $option_name ); ?>" value="<?php echo esc_attr($options[ $option_name ] ?? ''); ?>">
<p><?php esc_html_e('Enter your Facebook APP ID','hima-art-utility'); ?></p>
</label>
</div>
<?php
}

/* カードサイズ */
/* 項目の追加とデータの更新 */
function haumenu_init_field_ogp_card_size(){
//項目の追加
	add_settings_field(
		'ogp-card-size', // 設定名
		__('OGP Card Size Format','hima-art-utility'), // 設定タイトル
		'haumenu_ogp_card_size', // 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_03_optimize(), //表示させるタブのスラグ
		haumenu_define_section_id_03_optimize(),// $section 表示させるセクションのID
		array( 'class' => 'ha-settings-convine' )
	);

}

add_action( 'admin_init', 'haumenu_init_field_ogp_card_size' );

/* 入力フォーム */
function haumenu_ogp_card_size() {
	$set_name = haumenu_define_option_name_03_optimize(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'ogp-card-size'; //個別配列名

	if(isset($options[$option_name])){
		$selected = $options[$option_name];
	}else{
		$selected = '';
	}
?>
<div class="ogp-card-size-wrapper">
<select name= '<?php echo esc_html($set_name . '[' .$option_name. ']'); ?>' >
<option value='1' <?php selected($selected , 1 ); ?> selected ><?php esc_html_e('Large Image Card', 'hima-art-utility'); ?></option>
<option value='2' <?php selected($selected , 2 ); ?>><?php esc_html_e('Small Image Card', 'hima-art-utility'); ?></option>
</select>
</div>
<?php
}